<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="AssetSelector.aspx.cs" Inherits="Hdis.Connectors.Dam.Lytho.SitecoreXp.AssetSelector.AssetSelector" %>

<!DOCTYPE html>
<html>
<head>
    <meta charset="UTF-8" />
    <title>Asset Selector</title>

    <link href="css/dialog-1.0.0.css" rel="stylesheet">


    <script>
        var autoResizeOffset = 0;
        var multiImageMode = "<% = Mode %>" == "MultiImage";

        var result = { assets: [] };
        result.type = "Assets";

        window.addEventListener("message", event => {
            var func = event.data.function;
            var args = event.data.args;

            console.log(event.data);

            if (func == "place") {
                if (result.assets.find(e => e.id == args.id)) {
                    return;
                }

                result.assets.push(args);

                if (multiImageMode) {
                    handleMultiSelect(args);
                }
                else {
                    closeDialog();
                }
            }
        });

        function handleMultiSelect(args) {
            autoResizeOffset = 0 + 150;
            resizeContainer();

            var multiselect = document.getElementById("multiselect");
            multiselect.style.display = "block";

            var imgHtml = `<a onclick="removeFromSelection(this)" title="Click to remove from selection" id="${args.id}"><img src="${args.url}" /></a>`;
            multiselect.innerHTML += imgHtml;
        }

        function removeFromSelection(el) {
            var id = el.getAttribute("id");
            result.assets = result.assets.filter(e => e.id != id);
            document.getElementById(id).remove();

            console.log(result.assets);
        }

        function closeDialog() {
            if (window.radWindow) {
                window.radWindow.Close(result);
            }
            else if (window.frameElement && window.frameElement.radWindow) {
                window.frameElement.radWindow.Close(result);
            }
            else {
                var json = JSON.stringify(result);
                window.returnValue = json;
                window.top.returnValue = json;
                window.top.dialogClose();
            }
        }

        function resizeContainer() {
            var h = window.innerHeight;
            var container = document.getElementsByClassName("autoheight")[0];

            if (container) {
                container.style.height = (h - autoResizeOffset) + "px";
            }
        }

        window.addEventListener("load", event => {
            resizeContainer();
            window.onresize = resizeContainer;
        });
    </script>

</head>

<body>
    <div id="loader">
        <div class="spinner"></div>
    </div>

    <div id="compactViewContainer" class="autoheight">
        <span id="messagebox"></span>
        <iframe id="assetIframe" src="<% = AssetPickerUrl %>?type=<% = AssetTypes %>"></iframe>
    </div>

    <div id="multiselect">
        <button onclick="closeDialog()">Confirm selection</button>
    </div>

</body>
</html>
